unit IteratedFunctionSystems;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Spin, ExtCtrls, Menus, ClipBrd, Buttons;

type
  TIndex= Record von,bis:Integer;end;
  TIFS = class(TForm)
    OpenDialog: TOpenDialog;
    IFS_Datei: TGroupBox;
    Wahl: TListBox;
    IFS_Tabelle: TGroupBox;
    Tabelle: TStringGrid;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    LabelRL: TLabel;
    LabelRR: TLabel;
    LabelIO: TLabel;
    LabelIU: TLabel;
    LabelIT: TLabel;
    EditRL: TEdit;
    EditRR: TEdit;
    EditIO: TEdit;
    EditIU: TEdit;
    SpinEditIT: TSpinEdit;
    LabelRZ: TLabel;
    Zeichne: TButton;
    Bild: TPaintBox;
    Sichtbar: TCheckBox;
    MainMenu: TMainMenu;
    Datei: TMenuItem;
    Oeffnen: TMenuItem;
    Speichern: TMenuItem;
    N1: TMenuItem;
    Beenden: TMenuItem;
    Hilfe: TMenuItem;
    N2: TMenuItem;
    Info: TMenuItem;
    Hinweis: TMenuItem;
    SaveDialog: TSaveDialog;
    Neu: TMenuItem;
    Zwischenablage: TMenuItem;
    LabelHF: TLabel;
    LabelZF: TLabel;
    HFarben: TColorBox;
    Farben: TColorBox;
    Farbwahl: TRadioGroup;
    SBLeft: TSpeedButton;
    SBUp: TSpeedButton;
    SBRight: TSpeedButton;
    SBDown: TSpeedButton;
    SBIn: TSpeedButton;
    SBOut: TSpeedButton;
    BBReset: TBitBtn;
    SpinEditDY: TSpinEdit;
    LabelDY: TLabel;
    LabelZDY: TLabel;
    SpinEditDX: TSpinEdit;
    LabelDX: TLabel;
    LabelZDX: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure BBResetClick(Sender: TObject);
    procedure SBOutClick(Sender: TObject);
    procedure SBInClick(Sender: TObject);
    procedure SBDownClick(Sender: TObject);
    procedure SBUpClick(Sender: TObject);
    procedure SBRightClick(Sender: TObject);
    procedure SBLeftClick(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure FarbwahlClick(Sender: TObject);
    procedure FarbenClick(Sender: TObject);
    procedure HFarbenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure WahlClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ZeichneClick(Sender: TObject);
    procedure OeffnenClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure HinweisClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure BildPaint(Sender: TObject);
    procedure NeuClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure BildMouseDown(Sender: TObject; Button: TMouseButton;
                            Shift: TShiftState; X, Y: Integer);
    procedure BildMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure BildMouseUp(Sender: TObject; Button: TMouseButton;
                          Shift: TShiftState; X, Y: Integer);
    procedure ZwischenablageClick(Sender: TObject);
  private
    { Private-Deklarationen }
    // eigene Variablen
    Index:Array of TIndex;
    ZeilenZahl,IndexN:Integer;
    Eingabe:TStrings;
    BitMap:TBitMap;
    RechtEck:Array[1..2]of TPoint;
    Gezeichnet:Boolean;
    Hintergrund,FarbNr:TColor;
    DeltaX,DeltaY:Extended;
    // eigene Methoden
    procedure AddAt(Index:Integer;S:String);
    procedure InTabelle(Nr:Integer);
    function TimeSekunden:Extended;
    function Erlaubt(N:Integer):Boolean;
    procedure Loeschen;
  public
    { Public-Deklarationen }
  end;

var IFS: TIFS;

implementation

uses Info, HilfeRegeln;

{$R *.DFM}
{$R+,Q+}
 
 const FMax=15;
       PunktFarbe:Array[0..FMax]of TColor=
                     (clBlack, clMaroon, clGreen, clOlive,
                      clNavy, clPurple, clTeal, clDkGray,
                      clSilver, clRed, clLime,  clBlue,
                      clFuchsia, clAqua, clYellow, clWhite);

 function TIFS.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+S+MS/1000
  end;

 procedure TIFS.AddAt(Index:Integer;S:String);
  begin
  if Index>Wahl.Items.Count then Wahl.Items.Append(S)
  else
   begin
    if Index<0 then Index:=0;
    Wahl.Items.Insert(Index,S);
   end;
  end;

 procedure TIFS.InTabelle(Nr:Integer);
  var K,Spalte,Zeile:Integer;
      RB:TRadioButton;
  begin
   ZeilenZahl:=StrToInt(Eingabe[Index[Nr].von]);
   RB:=TRadioButton(FindComponent('RadioButton'+IntToStr(ZeilenZahl)));
   RB.Checked:=True;
   for Spalte:=0 to 6 do
    for Zeile:=1 to 8 do Tabelle.Cells[Spalte,Zeile]:='';
   Spalte:=0;Zeile:=0;
   for K:=Index[Nr].von+1 to Index[Nr].bis do
    begin
     inc(Zeile);
     if Zeile>ZeilenZahl then begin inc(Spalte);Zeile:=1 end;
     Tabelle.Cells[Spalte,Zeile]:=Eingabe[K];
    end;
  end;

 procedure TIFS.FarbenClick(Sender: TObject);
  begin
   FarbNr:=Farben.Selected;
  end;

 procedure TIFS.FarbwahlClick(Sender: TObject);
  begin
   if Farbwahl.ItemIndex=1 then Farben.Enabled:=True
   else Farben.Enabled:=False;
  end;

 procedure TIFS.FormActivate(Sender: TObject);
  var K,N:Integer;
      EZeile:String;
  begin
   if not FileExists('IFSDaten.IFS') then
    begin
     MessageDlg('Datei IFSDaten.IFS nicht gefunden!',mtError,[mbOk],0);
     exit;
    end;
   Wahl.Clear;IndexN:=-1; 
   Eingabe.LoadFromFile('IFSDaten.IFS');
   if Eingabe.Count=0 then exit;
   N:=-1;
   for K:=0 to Eingabe.Count-1 do
    begin
     EZeile:=Eingabe[K];
     if (EZeile[1]='[') and (EZeile[2]<>'#') then
      begin
       inc(N);
       if IndexN>=0 then Index[IndexN].bis:=K-1;
       inc(IndexN);
       Setlength(Index,IndexN+1);
       Index[IndexN].von:=K+1;
       AddAt(N,Copy(EZeile,2,Length(EZeile)-2))
      end;
    end;
   Index[IndexN].bis:=Eingabe.Count-2;
   Wahl.ItemIndex:=0;
   InTabelle(Wahl.ItemIndex);
   ZeichneClick(Self);
  end;

 procedure TIFS.FormCreate(Sender: TObject);
  var K:Integer;
  begin
   Randomize;Eingabe:=TStringList.Create;
   ZeilenZahl:=0;
   Gezeichnet:=False;
   FarbNr:=clGreen;Hintergrund:=clWhite;
   BitMap:=TBitMap.Create;
   BitMap.Height:=Bild.Height;
   BitMap.Width:=Bild.Width;
   Tabelle.Cells[0,0]:='  P in %';
   for K:=1 to 7 do Tabelle.Cells[K,0]:='      '+Char(K+64);
  end;

 procedure TIFS.WahlClick(Sender: TObject);
  begin
   InTabelle(Wahl.ItemIndex);
   ZeichneClick(Self);
  end;

 procedure TIFS.FormDestroy(Sender: TObject);
  begin
   Eingabe.Free;
   BitMap.Free
  end;

 procedure TIFS.EditKeyPress(Sender: TObject; var Key: Char);
  begin
   if not(Key in['0'..'9',',','-',#8]) then Key:=#0;
  end;

 function TIFS.Erlaubt(N:Integer):Boolean;
  var Zeile,Spalte:Integer;
  begin
   Result:=False;
   for Spalte:=0 to 6 do
    for Zeile:=1 to N do
     if Tabelle.Cells[Spalte,Zeile]='' then begin Result:=False;exit end
     else Result:=True;
  end;

 procedure TIFS.ZeichneClick(Sender: TObject);
  var Zufall,xNeu,yNeu,xMF,yMF,X,Y,xMin,xMax,yMax,yMin:Extended;
      xs,ys,I,MAX,MX,MY,K,L:Integer;
      Zeit:Extended;
      ZeitWert:String;
      a,b,c,d,e,f,p:Array[1..8]of Extended;
      Rect:TRect;
  begin
   if Not Erlaubt(ZeilenZahl) then
    begin
     MessageDlg('Du hast keine korrekte Matrix definiert!',mtError,[mbOk],0);
     exit
    end;
   if Farbwahl.ItemIndex=1 then
    if HFarben.Selected=Farben.Selected then
     begin
      MessageDlg('Du siehst doch NICHTS, du Blindfisch!',mtError,[mbRetry],0);
      exit;
     end;
   if EditRL.Text='' then
    begin
     MessageDlg('Du hast keinen Wert fr xMin definiert!',mtError,[mbRetry],0);
     exit
    end;
   if EditRR.Text='' then
    begin
     MessageDlg('Du hast keinen Wert fr xMax definiert!',mtError,[mbRetry],0);
     exit
    end;
   if EditIU.Text='' then
    begin
     MessageDlg('Du hast keinen Wert fr yMin definiert!',mtError,[mbRetry],0);
     exit
    end;
   if EditIO.Text='' then
    begin
     MessageDlg('Du hast keinen Wert fr yMax definiert!',mtError,[mbRetry],0);
     exit
    end;
   Bild.Canvas.Brush.Color:=Hintergrund;// Hintergrundfarbe
   Rect:=Bounds(0,0,Bild.Width,Bild.Height);
   Bild.Canvas.FillRect(Rect);// Zeichenflche fllen
   BitMap.Canvas.Brush.Color:=Hintergrund;// Hintergrundfarbe
   BitMap.Canvas.FillRect(Rect);// Zeichenflche fllen
   xMin:=StrToFloat(EditRL.Text);
   xMax:=StrToFloat(EditRR.Text);
   yMax:=StrToFloat(EditIO.Text);
   yMin:=StrToFloat(EditIU.Text);
   Max:=SpinEditIT.Value;
   MX:=Bild.Width;MY:=Bild.Height;
   if xMax<=xMin then
    begin
     MessageDlg('xMin ist zu gro!',mtError,[mbRetry],0);
     exit
    end;
   if yMax<=yMin then
    begin
     MessageDlg('yMin ist zu gro!',mtError,[mbRetry],0);
     exit
    end;
   xMF:=MX/(xMax-xMin);yMF:=MY/(yMax-yMin);
   for K:=1 to ZeilenZahl do p[K]:=StrToFloat(Tabelle.Cells[0,K])/100;
   for K:=1 to ZeilenZahl do a[K]:=StrToFloat(Tabelle.Cells[1,K]);
   for K:=1 to ZeilenZahl do b[K]:=StrToFloat(Tabelle.Cells[2,K]);
   for K:=1 to ZeilenZahl do c[K]:=StrToFloat(Tabelle.Cells[3,K]);
   for K:=1 to ZeilenZahl do d[K]:=StrToFloat(Tabelle.Cells[4,K]);
   for K:=1 to ZeilenZahl do e[K]:=StrToFloat(Tabelle.Cells[5,K]);
   for K:=1 to ZeilenZahl do f[K]:=StrToFloat(Tabelle.Cells[6,K]);
   Zeit:=TimeSekunden;
   Screen.Cursor:=crHourGlass;
   X:=0;Y:=0;
   for I:=1 to Max do
    begin
     Zufall:=Random;
     K:=ZeilenZahl;
     for L:=1 to ZeilenZahl do
      if Zufall<=p[L] then
       begin K:=L;break end;
     xNeu:=a[K]*x+b[K]*y+e[K];
     yNeu:=c[K]*x+d[K]*y+f[K];
     x:=xNeu;y:=yNeu;
     xs:=Round((x-xMin)*xMF);
     ys:=Round((yMax-y)*yMF);
     case Farbwahl.ItemIndex of
      0: FarbNr:=PunktFarbe[I mod FMax];
      1: FarbNr:=Farben.Selected;
      2: FarbNr:=Farben.Colors[K];
     end;
     BitMap.Canvas.Pixels[xs,ys]:=FarbNr;
     if Sichtbar.Checked then Bild.Canvas.Pixels[xs,ys]:=FarbNr;
    end;
   Zeit:=TimeSekunden-Zeit;
   ZeitWert:=FloatToStrF(Zeit,ffFixed,6,2);
   LabelRZ.Caption:='Rechenzeit='+#13+ZeitWert+' sek.';
   Screen.Cursor:=crDefault;
   Bild.Canvas.Draw(0,0,BitMap);
   Gezeichnet:=True;
  end;

 procedure TIFS.OeffnenClick(Sender: TObject);
  var K,N:Integer;
      EZeile:String;
  begin
   ForceCurrentDirectory:=True;
   Wahl.Clear;IndexN:=-1;
   with OpenDialog do
    begin
     Filter:='IFS-Dateien (*.IFS)|*.IFS|Text Files (*.txt)|*.txt|alle Files(*.*)|*.*';
     DefaultExt:='IFS';
     if Execute then Eingabe.LoadFromFile(FileName);
    end;
   if Eingabe.Count=0 then exit;
   N:=-1;
   for K:=0 to Eingabe.Count-1 do
    begin
     EZeile:=Eingabe[K];
     if (EZeile[1]='[') and (EZeile[2]<>'#') then
      begin
       inc(N);
       if IndexN>=0 then Index[IndexN].bis:=K-1;
       inc(IndexN);
       Setlength(Index,IndexN+1);
       Index[IndexN].von:=K+1;
       AddAt(N,Copy(EZeile,2,Length(EZeile)-2))
      end;
    end;
   Index[IndexN].bis:=Eingabe.Count-2;
   Wahl.ItemIndex:=0;
   InTabelle(Wahl.ItemIndex);
   ZeichneClick(Self);
  end;

 procedure TIFS.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TIFS.HFarbenClick(Sender: TObject);
  begin
   Hintergrund:=HFarben.Selected;
  end;

 procedure TIFS.HinweisClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

 procedure TIFS.BBResetClick(Sender: TObject);
  begin
   EditRL.Text:='-4,0';
   EditRR.Text:='5,0';
   EditIO.Text:='10,5';
   EditIU.Text:='-1,0';
   ZeichneClick(Self);
  end;

 procedure TIFS.BeendenClick(Sender: TObject);
  begin close end;

 procedure TIFS.SBLeftClick(Sender: TObject);
  begin
   DeltaX:=SpinEditDX.Value/10;
   EditRL.Text:=FloatToStr(StrToFloat(EditRL.Text)+DeltaX);
   EditRR.Text:=FloatToStr(StrToFloat(EditRR.Text)+DeltaX);
   ZeichneClick(Self);
  end;

 procedure TIFS.SBRightClick(Sender: TObject);
  begin
   DeltaX:=SpinEditDX.Value/10;
   EditRL.Text:=FloatToStr(StrToFloat(EditRL.Text)-DeltaX);
   EditRR.Text:=FloatToStr(StrToFloat(EditRR.Text)-DeltaX);
   ZeichneClick(Self);
  end;

 procedure TIFS.SBUpClick(Sender: TObject);
  begin
   DeltaY:=SpinEditDY.Value/10;
   EditIO.Text:=FloatToStr(StrToFloat(EditIO.Text)-DeltaY);
   EditIU.Text:=FloatToStr(StrToFloat(EditIU.Text)-DeltaY);
   ZeichneClick(Self);
  end;

 procedure TIFS.SBDownClick(Sender: TObject);
  begin
   DeltaY:=SpinEditDY.Value/10;
   EditIO.Text:=FloatToStr(StrToFloat(EditIO.Text)+DeltaY);
   EditIU.Text:=FloatToStr(StrToFloat(EditIU.Text)+DeltaY);
   ZeichneClick(Self);
  end;

 procedure TIFS.SBInClick(Sender: TObject);
  begin
   DeltaX:=SpinEditDX.Value/10;
   DeltaY:=SpinEditDY.Value/10;
   EditRL.Text:=FloatToStr(StrToFloat(EditRL.Text)-DeltaX);
   EditRR.Text:=FloatToStr(StrToFloat(EditRR.Text)+DeltaX);
   EditIO.Text:=FloatToStr(StrToFloat(EditIO.Text)+DeltaY);
   EditIU.Text:=FloatToStr(StrToFloat(EditIU.Text)-DeltaY);
   ZeichneClick(Self);
  end;

 procedure TIFS.SBOutClick(Sender: TObject);
  begin
   DeltaX:=SpinEditDX.Value/10;
   DeltaY:=SpinEditDY.Value/10;
   EditRL.Text:=FloatToStr(StrToFloat(EditRL.Text)+DeltaX);
   EditRR.Text:=FloatToStr(StrToFloat(EditRR.Text)-DeltaX);
   EditIO.Text:=FloatToStr(StrToFloat(EditIO.Text)-DeltaY);
   EditIU.Text:=FloatToStr(StrToFloat(EditIU.Text)+DeltaY);
   ZeichneClick(Self);
  end;

 procedure TIFS.SpeichernClick(Sender: TObject);
  var Zeile,Spalte:Integer;
      Titel:String;
  begin
   ForceCurrentDirectory:=True;
   with SaveDialog do
    begin
     Filter:='IFS-Dateien (*.IFS)|*.IFS|Text Files (*.txt)|*.txt|alle Files(*.*)|*.*';
     DefaultExt:='IFS';Options:=[ofOverwritePrompt];
     Eingabe.Clear;
     if Execute then
      begin
       if Wahl.ItemIndex>=0 then Titel:=Wahl.Items[Wahl.ItemIndex]
       else
        begin
         Titel:=ExtractFileName(FileName);
         Titel:=copy(Titel,1,Length(Titel)-4);
        end;
       Eingabe.Add('['+Titel+']');              // berschrift
       Eingabe.Add(IntToStr(ZeilenZahl));       // 2 - 8 Zeilen
       for Spalte:=0 to 6 do
        for Zeile:=1 to ZeilenZahl do
         Eingabe.Add(Tabelle.Cells[Spalte,Zeile]);
       Eingabe.Add('[#]');                      // Endemarkierung
       Eingabe.SaveToFile(FileName);
      end;
    end;
  end;

 procedure TIFS.BildPaint(Sender: TObject);
  begin Bild.Canvas.Draw(0,0,BitMap) end;

 procedure TIFS.NeuClick(Sender: TObject);
  var RB:TRadioButton;
      K,Spalte,Zeile:Integer;
      Rect:TRect;
  begin
   if MessageDlg('Sollen die alten Werte gelscht werden?',
                  mtConfirmation,[mbNo,mbYes],0)=mrNo then exit;
   Wahl.Clear;
   for K:=2 to 8 do
    begin
     RB:=TRadioButton(FindComponent('RadioButton'+IntToStr(K)));
     RB.Checked:=False;
    end;
   for Spalte:=0 to 6 do
    for Zeile:=1 to 8 do Tabelle.Cells[Spalte,Zeile]:='';
   Gezeichnet:=False;
   Bild.Canvas.Brush.Color:=Hintergrund;// Hintergrundfarbe
   Rect:=Bounds(0,0,Bild.Width,Bild.Height);
   Bild.Canvas.FillRect(Rect);// Zeichenflche fllen
  end;

 procedure TIFS.Loeschen;
  var Spalte,Zeile:Integer;
  begin
   for Spalte:=0 to 6 do
    for Zeile:=ZeilenZahl+1 to 8 do
     Tabelle.Cells[Spalte,Zeile]:=''
  end;

 procedure TIFS.RadioButton2Click(Sender: TObject);
  begin ZeilenZahl:=2;Loeschen; end;

 procedure TIFS.RadioButton3Click(Sender: TObject);
  begin ZeilenZahl:=3;Loeschen; end;

 procedure TIFS.RadioButton4Click(Sender: TObject);
  begin ZeilenZahl:=4;Loeschen; end;

 procedure TIFS.RadioButton5Click(Sender: TObject);
  begin ZeilenZahl:=5;Loeschen; end;

 procedure TIFS.RadioButton6Click(Sender: TObject);
  begin ZeilenZahl:=6;Loeschen; end;

 procedure TIFS.RadioButton7Click(Sender: TObject);
  begin ZeilenZahl:=7;Loeschen; end;

 procedure TIFS.RadioButton8Click(Sender: TObject);
  begin ZeilenZahl:=8;Loeschen; end;

 procedure TIFS.BildMouseDown(Sender: TObject; Button: TMouseButton;
                              Shift: TShiftState; X, Y: Integer);
  begin
   if (Shift=[ssLeft]) and Gezeichnet then
    begin
     Bild.Canvas.Brush.Style:=bsClear;
     Bild.Canvas.Pen.Mode:=pmNotXor;
     Bild.Canvas.Pen.Style:=psDot;
     Bild.Canvas.Pen.Color:=clBlack;
     if Hintergrund=clBlack then Bild.Canvas.Pen.Color:=clWhite;
     Bild.Canvas.Rectangle(RechtEck[1].X,RechtEck[1].Y,RechtEck[2].X,RechtEck[2].Y);
     RechtEck[1].X:=X;RechtEck[1].Y:=Y;
     RechtEck[2].X:=X;RechtEck[2].Y:=Y;
     Bild.Canvas.Rectangle(RechtEck[1].X,RechtEck[1].Y,RechtEck[2].X,RechtEck[2].Y);
    end;
  end;

 procedure TIFS.BildMouseMove(Sender: TObject; Shift:TShiftState;X,Y:Integer);
  begin
   if (Shift=[ssLeft]) and Gezeichnet then
    begin
     Bild.Canvas.Rectangle(RechtEck[1].X,RechtEck[1].Y,RechtEck[2].X,RechtEck[2].Y);
     RechtEck[2].X:=X;RechtEck[2].Y:=Y;
     Bild.Canvas.Rectangle(RechtEck[1].X,RechtEck[1].Y,RechtEck[2].X,RechtEck[2].Y);
    end;
  end;

 procedure TIFS.BildMouseUp(Sender: TObject; Button: TMouseButton;
                            Shift: TShiftState; X, Y: Integer);
  begin
   Bild.Canvas.Pen.Mode:=pmCopy;
   ZwischenablageClick(Self);
  end;

 procedure TIFS.ZwischenablageClick(Sender: TObject);
  var  BildAusschnitt: TBitmap;
       Weite,Hoehe:Integer;
       Ziel,Quelle:TRect;
  begin
   Screen.Cursor:=crHourGlass;
   BildAusschnitt:=TBitmap.Create;
   Weite:=RechtEck[2].X-RechtEck[1].X-2;
   Hoehe:=RechtEck[2].Y-RechtEck[1].Y-2;
   if (Hoehe<2) or (Weite<2) then
    begin
     BildAusschnitt.Free;
     Screen.Cursor:=crDefault;
     exit;
    end;
   Quelle:=Bounds(RechtEck[1].X+1,RechtEck[1].Y+1,Weite+1,Hoehe+1);
   Ziel:=Bounds(0,0,Weite,Hoehe);
   BildAusschnitt.Width:=Weite;
   BildAusschnitt.Height:=Hoehe;
   BildAusschnitt.Canvas.CopyRect(Ziel,Bild.Canvas,Quelle);
   Clipboard.Assign(BildAusschnitt);
   BildAusschnitt.Free;
   Screen.Cursor:=crDefault;
   Beep;
  end;

end.


